#include "MokoAcc.h"
#include <iostream>
#include <fcntl.h>


MokoAcc::MokoAcc(int Number, int myLoops)
{
///neo_t initialisieren mit 0
Val[0] = 0.0;
Val[1] = 0.0;
Val[2] = 0.0;
AccelNumber = Number;
Loops=myLoops;
ValueCount=1;
}

/// opens one accelerometer
void MokoAcc::Open()
{ 
        
        if (AccelNumber == 1) 
        {
                Acc = open("/dev/input/event2", O_RDONLY);
				std::cout << "Reading /dev/input/event2"<<std::endl;
                LogFileName ="AccLog_Acc1.txt";
                LogFile.open(LogFileName);
        } 
        else if (AccelNumber == 2) 
        {
                Acc = open("/dev/input/event3", O_RDONLY);
				std::cout << "Reading /dev/input/event3"<<std::endl;
                LogFileName = "AccLog_Acc2.txt";
                LogFile.open(LogFileName);
        }
        LoopFlag = true;
}

/// closes the accelerometer
void MokoAcc::Close()
{
        LoopFlag = false;
        close(Acc);
        LogFile.close();
}

/// begins reading the accelerometer
void MokoAcc::Read()
{
    const unsigned int ReportLength = 16;
    unsigned char Report[ReportLength];
    fd_set readfd;
    FD_ZERO(&readfd);
    FD_SET(Acc,&readfd);
    int AccValueMG;
    while (LoopFlag)
    {
        ///* Check if Data is available else wait
        if (select(Acc+1, &readfd, NULL,NULL, NULL)) 
        {
            read(Acc, Report, ReportLength);

            //next 4 Bytes -> useconds
            uSeconds = *(int *)(Report + 4);

            // conversion to mseconds
            TimeInMs = uSeconds/1000.000;

            // next 2 Bytes: Rel=0 -> Separator Rel=2 -> Message
            unsigned short int Rel = *(unsigned short int *)(Report + 8);
            if (Rel==2) 
            {   
                // next 2 Bytes: Axis Index 0->X  1->Y 2->Z
                unsigned short int AxisIndex = *(unsigned short int *)(Report + 10);
                // next 4 Bytes: ACC Value in milli G
                AccValueMG = *(int *)(Report + 12);
                // transform mG -> m/s
                Val[AxisIndex] = (AccValueMG/1000.000)*9.780318;
            }
            if (Rel == 0)
            {
                LogFile <<std::fixed<< TimeInMs <<" " << Val[0] << " " << Val[1] << " " << Val[2] << std::endl;
                if (ValueCount==Loops)return;
                ValueCount++;     
            }
        }
    }
}

void MokoAcc::SetParams(int SampleRate, int threshold)
{
	char FileName1[] = "/sys/class/i2c-adapter/i2c-0/0-0073/lis302dl.1/sample_rate";
	char FileName2[] = "/sys/class/i2c-adapter/i2c-0/0-0073/lis302dl.2/sample_rate";
    char FileName3[] = "/sys/class/i2c-adapter/i2c-0/0-0073/lis302dl.1/threshold";
    char FileName4[] = "/sys/class/i2c-adapter/i2c-0/0-0073/lis302dl.2/threshold";
	std::ofstream spi0(FileName1, std::ios::out);
	std::ofstream spi1(FileName2, std::ios::out);
    std::ofstream spi02(FileName3, std::ios::out);
    std::ofstream spi12(FileName4, std::ios::out);
	spi0 << SampleRate << "\n";
	spi1 << SampleRate << "\n";
    spi02 << threshold << "\n";
    spi12 << threshold << "\n";
	spi0.close();
	spi1.close();
    spi02.close();
    spi12.close();
}
